> ## Documentation Index
> Fetch the complete documentation index at: https://docs.dify.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Delete Document

> Permanently delete a document and all its chunks from the knowledge base.



## OpenAPI

````yaml /en/api-reference/openapi_knowledge.json delete /datasets/{dataset_id}/documents/{document_id}
openapi: 3.0.1
info:
  title: Knowledge API
  description: >-
    API for managing knowledge bases, documents, chunks, metadata, and tags,
    including creation, retrieval, and configuration. **Note:** A single
    Knowledge Base API key has permission to operate on all visible knowledge
    bases under the same account. Please pay attention to data security.
  version: 1.0.0
servers:
  - url: '{apiBaseUrl}'
    description: The base URL for the Knowledge API.
    variables:
      apiBaseUrl:
        default: https://api.dify.ai/v1
        description: Actual base URL of the API
security:
  - ApiKeyAuth: []
tags:
  - name: Knowledge Bases
    description: >-
      Operations for managing knowledge bases, including creation,
      configuration, and retrieval.
  - name: Documents
    description: >-
      Operations for creating, updating, and managing documents within a
      knowledge base.
  - name: Chunks
    description: Operations for managing document chunks and child chunks.
  - name: Metadata
    description: >-
      Operations for managing knowledge base metadata fields and document
      metadata values.
  - name: Tags
    description: Operations for managing knowledge base tags and tag bindings.
  - name: Models
    description: Operations for retrieving available models.
  - name: Knowledge Pipeline
    description: >-
      Operations for managing and running knowledge pipelines, including
      datasource plugins and pipeline execution.
paths:
  /datasets/{dataset_id}/documents/{document_id}:
    delete:
      tags:
        - Documents
      summary: Delete Document
      description: >-
        Permanently delete a document and all its chunks from the knowledge
        base.
      operationId: deleteDocument
      parameters:
        - name: dataset_id
          in: path
          required: true
          schema:
            type: string
            format: uuid
          description: Knowledge base ID.
        - name: document_id
          in: path
          required: true
          schema:
            type: string
            format: uuid
          description: Document ID.
      responses:
        '204':
          description: Success.
        '400':
          description: '`document_indexing` : Cannot delete document during indexing.'
          content:
            application/json:
              examples:
                document_indexing:
                  summary: document_indexing
                  value:
                    status: 400
                    code: document_indexing
                    message: Cannot delete document during indexing.
        '403':
          description: >-
            `archived_document_immutable` : The archived document is not
            editable.
          content:
            application/json:
              examples:
                archived_document_immutable:
                  summary: archived_document_immutable
                  value:
                    status: 403
                    code: archived_document_immutable
                    message: The archived document is not editable.
        '404':
          description: '`not_found` : Document Not Exists.'
          content:
            application/json:
              examples:
                not_found:
                  summary: not_found
                  value:
                    status: 404
                    code: not_found
                    message: Document Not Exists.
components:
  securitySchemes:
    ApiKeyAuth:
      type: http
      scheme: bearer
      bearerFormat: API_KEY
      description: >-
        API Key authentication. For all API requests, include your API Key in
        the `Authorization` HTTP Header, prefixed with `Bearer `. Example:
        `Authorization: Bearer {API_KEY}`. **Strongly recommend storing your API
        Key on the server-side, not shared or stored on the client-side, to
        avoid possible API-Key leakage that can lead to serious consequences.**

````